diff -rupN /usr/src/linux-2.4.9/kernel/exit.c linux-kgdb/kernel/exit.c
--- /usr/src/linux-2.4.9/kernel/exit.c	Fri Aug 24 00:13:25 2001
+++ linux-kgdb/kernel/exit.c	Sat Aug 25 01:18:48 2001
@@ -438,6 +438,13 @@ fake_volatile:
 #ifdef CONFIG_BSD_PROCESS_ACCT
 	acct_process(code);
 #endif
+#if defined(CONFIG_AIO)
+	if (tsk->kaio_info) {
+		extern void kaio_exit(void);
+
+		kaio_exit();
+	}
+#endif
 	__exit_mm(tsk);
 
 	lock_kernel();
diff -rupN /usr/src/linux-2.4.9/kernel/fork.c linux-kgdb/kernel/fork.c
--- /usr/src/linux-2.4.9/kernel/fork.c	Sat Jul 21 20:20:59 2001
+++ linux-kgdb/kernel/fork.c	Sat Aug 25 01:18:48 2001
@@ -680,6 +680,13 @@ int do_fork(unsigned long clone_flags, u
 	if (!current->counter)
 		current->need_resched = 1;
 
+#if defined(CONFIG_AIO)
+	if (current->kaio_info) {
+		extern int kaio_fork(struct task_struct *, int);
+
+		kaio_fork(p, clone_flags);
+	}
+#endif
 	/*
 	 * Ok, add it to the run-queues and make it
 	 * visible to the rest of the system.
diff -rupN /usr/src/linux-2.4.9/kernel/ksyms.c linux-kgdb/kernel/ksyms.c
--- /usr/src/linux-2.4.9/kernel/ksyms.c	Fri Aug 24 00:13:25 2001
+++ linux-kgdb/kernel/ksyms.c	Sun Aug 26 18:21:42 2001
@@ -439,7 +439,10 @@ EXPORT_SYMBOL(sleep_on);
 EXPORT_SYMBOL(sleep_on_timeout);
 EXPORT_SYMBOL(interruptible_sleep_on);
 EXPORT_SYMBOL(interruptible_sleep_on_timeout);
-EXPORT_SYMBOL(schedule);
+EXPORT_SYMBOL(do_schedule);
+#ifdef CONFIG_KGDB_THREAD
+EXPORT_SYMBOL(kern_schedule);
+#endif
 EXPORT_SYMBOL(schedule_timeout);
 EXPORT_SYMBOL(jiffies);
 EXPORT_SYMBOL(xtime);
diff -rupN /usr/src/linux-2.4.9/kernel/sched.c linux-kgdb/kernel/sched.c
--- /usr/src/linux-2.4.9/kernel/sched.c	Sat Jul 21 20:20:59 2001
+++ linux-kgdb/kernel/sched.c	Sun Aug 26 18:21:42 2001
@@ -527,7 +527,7 @@ void schedule_tail(struct task_struct *p
  * tasks can run. It can not be killed, and it cannot sleep. The 'state'
  * information in task[0] is never used.
  */
-asmlinkage void schedule(void)
+asmlinkage void do_schedule(void)
 {
 	struct schedule_data * sched_data;
 	struct task_struct *prev, *next, *p;
@@ -706,6 +706,22 @@ scheduling_in_interrupt:
 	BUG();
 	return;
 }
+
+asmlinkage void user_schedule(void)
+{
+#ifdef CONFIG_KGDB_THREAD
+	current->thread.kgdbregs = NULL;
+#endif
+	do_schedule();
+}
+
+#ifdef CONFIG_KGDB_THREAD
+asmlinkage void kern_do_schedule(struct pt_regs regs)
+{
+	current->thread.kgdbregs = &regs;
+	do_schedule();
+}
+#endif
 
 /*
  * The core wakeup function.  Non-exclusive wakeups (nr_exclusive == 0) just wake everything
diff -rupN /usr/src/linux-2.4.9/mm/filemap.c linux-kgdb/mm/filemap.c
--- /usr/src/linux-2.4.9/mm/filemap.c	Fri Aug 24 00:13:25 2001
+++ linux-kgdb/mm/filemap.c	Sun Aug 26 20:36:51 2001
@@ -2,6 +2,13 @@
  *	linux/mm/filemap.c
  *
  * Copyright (C) 1994-1999  Linus Torvalds
+ * 
+ * KAIO modifications:
+ * 	Copyright 1999, Silicon Graphics, Inc.
+ *
+ * 	Written October 1999 by Rajagopal Ananthanarayanan (ananth)
+ *                      at Silicon Graphics, Inc.
+ * 	With modifications suggested by Doug Rady at Silicon Graphics, Inc.
  */
 
 /*
@@ -29,6 +36,25 @@
 
 #include <linux/highmem.h>
 
+#if defined(CONFIG_AIO)
+#include <linux/aio.h>
+
+#ifdef AIO_DEBUG
+#define	assert(expression) { \
+	if (!(expression)) { \
+		(void)printk(KERN_ERR \
+			"assertion \"%s\" failed: file \"%s\", line %d\n", \
+			#expression, \
+			__FILE__, __LINE__); \
+	} \
+}
+#else
+#define assert(expresssion)
+#endif
+
+#define pageof(x)	(x >> PAGE_SHIFT)
+#endif /* CONFIG_AIO */
+
 /*
  * Shared mappings implemented 30.11.1994. It's not fully working yet,
  * though.
